package com.qmth.ops.api.controller.admin;

import com.qmth.ops.api.constants.OpsApiConstants;
import com.qmth.ops.biz.domain.ConfigItem;
import com.qmth.ops.biz.service.AppService;
import com.qmth.ops.biz.service.ConfigService;
import com.qmth.ops.biz.service.ModuleService;
import com.qmth.ops.biz.service.VersionService;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;
import org.springframework.web.multipart.MultipartFile;

import javax.annotation.Resource;
import java.io.IOException;
import java.util.List;

@RestController
@RequestMapping(OpsApiConstants.ADMIN_URI_PREFIX + "/app")
public class ConfigController {

    @Resource
    private ConfigService configService;

    @Resource
    private AppService appService;

    @Resource
    private ModuleService moduleService;

    @Resource
    private VersionService versionService;

    @PostMapping("/baseline")
    public List<ConfigItem> listBaseline(@RequestParam Long appId, @RequestParam Long versionId,
            @RequestParam Long moduleId) {
        return configService.listBaseline(appId, versionId, moduleId);
    }

    @PostMapping("/baseline/update")
    public Object updateBaseline(@RequestParam Long appId, @RequestParam Long versionId, @RequestParam Long moduleId,
            @RequestParam MultipartFile file, @RequestParam(required = false) Long inheritVersionId)
            throws IOException {
        return configService.updateBaseline(appService.findById(appId), versionService.findByid(versionId),
                moduleService.findById(moduleId), file.getInputStream(),
                inheritVersionId != null ? versionService.findByid(inheritVersionId) : null);
    }

    @PostMapping("/baseline/item/update")
    public ConfigItem updateBaselineItem(ConfigItem item) {
        return configService.updateBaselineItem(item);
    }

    @PostMapping("/list")
    public List<ConfigItem> listConfigItem(@RequestParam Long appId, @RequestParam Long versionId,
            @RequestParam Long moduleId, @RequestParam Long envId) {
        return configService.listConfigItem(appId, versionId, moduleId, envId);
    }

    @PostMapping("/item/update")
    public ConfigItem updateConfigItem(ConfigItem item) {
        return configService.updateConfigItem(item);
    }
}

