package com.qmth.ops.biz.domain;

public enum ConfigFormat {

    PROPERTY("properties"), JSON("json");

    private String extension;

    private ConfigFormat(String extension) {
        this.extension = extension;
    }

    public String getExtension() {
        return extension;
    }

    public static ConfigFormat findByExtension(String extension) {
        for (ConfigFormat format : values()) {
            if (format.getExtension().equalsIgnoreCase(extension)) {
                return format;
            }
        }
        return null;
    }
}
